typedef long  _INTEGER;
typedef char* _ADDRESS;
typedef void (*_PROC)();

typedef struct module {
  _ADDRESS  file;
  _ADDRESS  type_cells;
  _ADDRESS  type_cell_ptrs;
  _ADDRESS  full_revelations;
  _ADDRESS  partial_revelations;
  _ADDRESS  proc_info;
  _ADDRESS  try_scopes;
  _ADDRESS  var_map;
  _ADDRESS  gc_map;
  _PROC     link;
  _PROC     main;
} _MODULE;

typedef struct link_info {
  _INTEGER n_modules;
  _ADDRESS modules;
  _INTEGER argc;
  _ADDRESS argv;
  _ADDRESS envp;
  _ADDRESS instance;
  _ADDRESS bottom_of_stack;
  _ADDRESS top_of_stack;
} _LINK_INFO;

typedef struct {
  _MODULE     module;
  _ADDRESS    info_typecell[26];
  _LINK_INFO *info;
} _LINKER;


struct {
  struct { int FmtBuf; } FmtBufTest;
  struct { int TrestleOnX; } TrslOnXF;
  struct { int Property; } PropertyF;
  struct { int VideoVBT; } VideoVBTRep;
  struct { int TickPortable; } Tick;
  struct { int PictureImpl; int Picture; } Picture;
  struct { int XSharedFree; int XSharedMem; } XSharedMem;
  struct { int XPictureFree; int XPicture; } XPicture;
  struct { int PictureImpl; int Picture; } PictureRep;
  struct { int TCP; } TCPSpecial;
  struct { int FSPosix; } FS;
  struct { int BorderedVBT; } BdrVBTClass;
  struct { int BatchUtil; } BatchRep;
  struct { int ThreadPosix; } Scheduler;
  struct { int Trestle; } TrestleImpl;
  struct { int RTException; } RTExRep;
  struct { int PathnamePosix; } Pathname;
  struct { int RTType; } RTTypeSRC;
  struct { int FormsVBT; int FVRuntime; } FVTypes;
  struct { int RTProcedure; } RTProcedureSRC;
  struct { int RTThread; int RTThreadStk; } RTThread;
  struct { int ThreadPosix; } ThreadF;
  struct { int ThreadPosix; } RTThreadInit;
  struct { int FormsVBT; int FVRuntime; } FVRuntime;
  struct { int DateLinux; } Date;
  struct { int TimePosix; } Time;
  struct { int Text; } TextF;
  struct { int Bundle; } BundleRep;
  struct { int RTCollector; } RTWeakRef;
  struct { int Path; } PathPrivate;
  struct { int RdMove; } RdClass;
  struct { int WrMove; } WrClass;
  struct { int RTAllocator; int RTHooks; int ThreadPosix; } RTHooks;
  struct { int Text; int UnsafeHash; } Text;
  struct { int WrPosix; int WrMove; } Wr;
  struct { int ProcessPosix; } Process;
  struct { int OSErrorPosix; } OSError;
  struct { int FormsVBT; int FVRuntime; } FormsVBT;
  struct { int RdImpl; int RdMove; } Rd;
  struct { int ThreadPosix; } Thread;
  struct { int Utex2; } Main;
  struct { int Pipe; int PipePosix; } Pipe;
  struct { int ThreadPosix; } SchedulerPosix;
  struct { int MachineIDPosix; } MachineID;
  struct { int MText; } MTextPrivate;
  struct { int ColorName; } ColorNameF;
  struct { int Uin; int TCP; } Uin;
  struct { int RdMove; } UnsafeRd;
  struct { int WrMove; } UnsafeWr;
  struct { int RTHeapRep; int RTCollector; } RTHeapRep;
  struct { int RTCollector; } RTCollectorSRC;
  struct { int FmtBuf; } FmtBufF;
} * _m3_exporters;

extern _MODULE MM_XPaint;
extern _MODULE MM_XGC;
extern _MODULE MM_Extended;
extern _MODULE MM_Fingerprint;
extern _MODULE MM_XScrnFont;
extern _MODULE MM_XScrnCrsr;
extern _MODULE MM_Swap;
extern _MODULE MM_XScrnPntOp;
extern _MODULE MM_XScrnTpRep;
extern _MODULE MM_XScrnPxmp;
extern _MODULE MM_XClientF;
extern _MODULE MM_TrestleOnX;
extern _MODULE MM_IntRefTbl;
extern _MODULE MM_OSErrorPosix;
extern _MODULE MM_XClient;
extern _MODULE MM_Refany;
extern _MODULE MM_MiscDetail;
extern _MODULE MM_TextRefTbl;
extern _MODULE MM_WeakRef;
extern _MODULE MM_JVFromSource;
extern _MODULE MM_JVSinkPool;
extern _MODULE MM_TrestleGoo;
extern _MODULE MM_RTArgs;
extern _MODULE MM_RTType;
extern _MODULE MM_Property;
extern _MODULE MM_AtomAtomTbl;
extern _MODULE MM_Unetdb;
extern _MODULE MM_DpyFilter;
extern _MODULE MM_InstallQueue;
extern _MODULE MM_InstalledVBT;
extern _MODULE MM_TrestleOS;
extern _MODULE MM_TrestleConf;
extern _MODULE MM_ScrnColorMap;
extern _MODULE MM_Point;
extern _MODULE MM_JVBuffer;
extern _MODULE MM_JVFromDecomp;
extern _MODULE MM_JVDecomp;
extern _MODULE MM_JVDecompPool;
extern _MODULE MM_Jvs;
extern _MODULE MM_JvsBuffer;
extern _MODULE MM_Region;
extern _MODULE MM_PaintPrivate;
extern _MODULE MM_XScrnCmap;
extern _MODULE MM_TrestleClass;
extern _MODULE MM_XScreenType;
extern _MODULE MM_Picture;
extern _MODULE MM_TextSeq;
extern _MODULE MM_Rect;
extern _MODULE MM_Jv;
extern _MODULE MM_AtomList;
extern _MODULE MM_JVAudio;
extern _MODULE MM_JVConverter;
extern _MODULE MM_TCPHack;
extern _MODULE MM_ScreenType;
extern _MODULE MM_XPicture;
extern _MODULE MM_XSharedMem;
extern _MODULE MM_PictureImpl;
extern _MODULE MM_Integer;
extern _MODULE MM_StableVBT;
extern _MODULE MM_Completion;
extern _MODULE MM_ShadowedBarVBT;
extern _MODULE MM_CompletionSeq;
extern _MODULE MM_VideoVBT;
extern _MODULE MM_ZGrowVBT;
extern _MODULE MM_ZTilps;
extern _MODULE MM_RealFloat;
extern _MODULE MM_RegularFile;
extern _MODULE MM_LongReal;
extern _MODULE MM_LongFloat;
extern _MODULE MM_Math;
extern _MODULE MM_RigidVBT;
extern _MODULE MM_ZMoveVBT;
extern _MODULE MM_ETAgent;
extern _MODULE MM_PackSplit;
extern _MODULE MM_AtomIntTbl;
extern _MODULE MM_BiFeedbackVBT;
extern _MODULE MM_FeedbackVBT;
extern _MODULE MM_Image;
extern _MODULE MM_MarginFeedbackVBT;
extern _MODULE MM_MultiFilter;
extern _MODULE MM_ViewportVBT;
extern _MODULE MM_Pixmap;
extern _MODULE MM_Key;
extern _MODULE MM_Batch;
extern _MODULE MM_BatchUtil;
extern _MODULE MM_JoinScreen;
extern _MODULE MM_ScrnCursor;
extern _MODULE MM_ScrnPaintOp;
extern _MODULE MM_Trapezoid;
extern _MODULE MM_ScrnPixmap;
extern _MODULE MM_ShadowPaint;
extern _MODULE MM_VBTKitResources;
extern _MODULE MM_HVBar;
extern _MODULE MM_JoinedVBT;
extern _MODULE MM_JoinParent;
extern _MODULE MM_OffsetVBT;
extern _MODULE MM_AutoRepeat;
extern _MODULE MM_VBTColors;
extern _MODULE MM_Pickle;
extern _MODULE MM_RTHeapInfo;
extern _MODULE MM_VBTKitBundle;
extern _MODULE MM_PropertyV;
extern _MODULE MM_RTModule;
extern _MODULE MM_RTMapOp;
extern _MODULE MM_RTHeapMap;
extern _MODULE MM_IntIntTbl;
extern _MODULE MM_RTProcedure;
extern _MODULE MM_RTThreadStk;
extern _MODULE MM_Axis;
extern _MODULE MM_Cursor;
extern _MODULE MM_MenuBtnVBT;
extern _MODULE MM_ScrollerVBTClass;
extern _MODULE MM_AnchorBtnVBT;
extern _MODULE MM_Color;
extern _MODULE MM_ProperSplit;
extern _MODULE MM_AnchorSplit;
extern _MODULE MM_AnyEvent;
extern _MODULE MM_AudioVBT;
extern _MODULE MM_FormsVBTPixmapsBundle;
extern _MODULE MM_BooleanVBT;
extern _MODULE MM_BorderedVBT;
extern _MODULE MM_ButtonVBT;
extern _MODULE MM_ChoiceVBT;
extern _MODULE MM_VBTutils;
extern _MODULE MM_ColorName;
extern _MODULE MM_FlexVBT;
extern _MODULE MM_FileBrowserVBT;
extern _MODULE MM_FileRd;
extern _MODULE MM_RTOS;
extern _MODULE MM_RTException;
extern _MODULE MM_Font;
extern _MODULE MM_GuardedBtnVBT;
extern _MODULE MM_HighlightVBT;
extern _MODULE MM_HVSplit;
extern _MODULE MM_Jva;
extern _MODULE MM_JVSink;
extern _MODULE MM_ListVBT;
extern _MODULE MM_MenuSwitchVBT;
extern _MODULE MM_MultiClass;
extern _MODULE MM_MultiSplit;
extern _MODULE MM_NumericVBT;
extern _MODULE MM_PaintOp;
extern _MODULE MM_PixmapVBT;
extern _MODULE MM_Pts;
extern _MODULE MM_ReactivityVBT;
extern _MODULE MM_ScaleFilter;
extern _MODULE MM_ScrollerVBT;
extern _MODULE MM_Shadow;
extern _MODULE MM_ShadowedVBT;
extern _MODULE MM_ShadowedFeedbackVBT;
extern _MODULE MM_SortedTextRefTbl;
extern _MODULE MM_SourceVBT;
extern _MODULE MM_Split;
extern _MODULE MM_SplitterVBT;
extern _MODULE MM_SwitchVBT;
extern _MODULE MM_TextPortClass;
extern _MODULE MM_TextRd;
extern _MODULE MM_TextureVBT;
extern _MODULE MM_TextVBT;
extern _MODULE MM_TextWr;
extern _MODULE MM_TrillSwitchVBT;
extern _MODULE MM_TSplit;
extern _MODULE MM_TextIntTbl;
extern _MODULE MM_TypeinVBT;
extern _MODULE MM_TypescriptVBT;
extern _MODULE MM_ZChassisVBT;
extern _MODULE MM_ZChildVBT;
extern _MODULE MM_ZSplit;
extern _MODULE MM_ZSplitUtils;
extern _MODULE MM_StubImageRd;
extern _MODULE MM_StubImageVBT;
extern _MODULE MM_Path;
extern _MODULE MM_IvyModel;
extern _MODULE MM_JoinCMap;
extern _MODULE MM_RT0u;
extern _MODULE MM_RTPerfTool;
extern _MODULE MM_JoinCursor;
extern _MODULE MM_RTThread;
extern _MODULE MM_RTIO;
extern _MODULE MM_JoinFont;
extern _MODULE MM_STypeMapSeq;
extern _MODULE MM_JoinPixmap;
extern _MODULE MM_PlttFrnds;
extern _MODULE MM_JoinPaintOp;
extern _MODULE MM_MTextRd;
extern _MODULE MM_SelectQueue;
extern _MODULE MM_TextEditVBT;
extern _MODULE MM_VText;
extern _MODULE MM_KeyTrans;
extern _MODULE MM_MTextUnit;
extern _MODULE MM_EmacsModel;
extern _MODULE MM_XtermModel;
extern _MODULE MM_AtomRefTbl;
extern _MODULE MM_Compl;
extern _MODULE MM_ComplSeq;
extern _MODULE MM_XPictureFree;
extern _MODULE MM_XSharedFree;
extern _MODULE MM_ASCII;
extern _MODULE MM_DragonInt;
extern _MODULE MM_FVRuntime;
extern _MODULE MM_Sx;
extern _MODULE MM_Macro;
extern _MODULE MM_DragonT;
extern _MODULE MM_TextPort;
extern _MODULE MM_FPU;
extern _MODULE MM_Atom;
extern _MODULE MM_RefList;
extern _MODULE MM_RefListUtils;
extern _MODULE MM_TickPortable;
extern _MODULE MM_DateLinux;
extern _MODULE MM_TimePosix;
extern _MODULE MM_CConvert;
extern _MODULE MM_UnsafeHash;
extern _MODULE MM_M3toC;
extern _MODULE MM_Word;
extern _MODULE MM_Bundle;
extern _MODULE MM_Env;
extern _MODULE MM_KeyFilter;
extern _MODULE MM_TimeStamp;
extern _MODULE MM_MacModel;
extern _MODULE MM_Real;
extern _MODULE MM_Poly;
extern _MODULE MM_PolyBasis;
extern _MODULE MM_VT;
extern _MODULE MM_Interval;
extern _MODULE MM_MD2;
extern _MODULE MM_RdMove;
extern _MODULE MM_WrMove;
extern _MODULE MM_Filter;
extern _MODULE MM_ThreadPosix;
extern _MODULE MM_VTPounce;
extern _MODULE MM_FilterClass;
extern _MODULE MM_VBTRep;
extern _MODULE MM_VBTClass;
extern _MODULE MM_MouseSplit;
extern _MODULE MM_TCP;
extern _MODULE MM_FSPosix;
extern _MODULE MM_RTHooks;
extern _MODULE MM_IP;
extern _MODULE MM_PipePosix;
extern _MODULE MM_Text;
extern _MODULE MM_Convert;
extern _MODULE MM_Tempo;
extern _MODULE MM_PathnamePosix;
extern _MODULE MM_IO;
extern _MODULE MM_Stdio;
extern _MODULE MM_RdUtils;
extern _MODULE MM_VTMarker;
extern _MODULE MM_ConnMsgRW;
extern _MODULE MM_VTInterval;
extern _MODULE MM_VTTexture;
extern _MODULE MM_Usignal;
extern _MODULE MM_Random;
extern _MODULE MM_Params;
extern _MODULE MM_PolyRegion;
extern _MODULE MM_FileWr;
extern _MODULE MM_FloatMode;
extern _MODULE MM_Fmt;
extern _MODULE MM_FormsVBT;
extern _MODULE MM_Lex;
extern _MODULE MM_Rsrc;
extern _MODULE MM_Scan;
extern _MODULE MM_Trestle;
extern _MODULE MM_VBT;
extern _MODULE MM_Utex2;
extern _MODULE MM_CalculatorBundle;
extern _MODULE MM_RTLinker;
extern _MODULE MM_RTProcess;
extern _MODULE MM_RTSignal;
extern _MODULE MM_ProcessPosix;
extern _MODULE MM_RefListSort;
extern _MODULE MM_Palette;
extern _MODULE MM_ScrnFont;
extern _MODULE MM_VTCaret;
extern _MODULE MM_VTRd;
extern _MODULE MM_VTBase;
extern _MODULE MM_Pipe;
extern _MODULE MM_Terminal;
extern _MODULE MM_RandomReal;
extern _MODULE MM_VTReal;
extern _MODULE MM_VTView;
extern _MODULE MM_VTVirtual;
extern _MODULE MM_VTextRegion;
extern _MODULE MM_MachineIDPosix;
extern _MODULE MM_MTextDs;
extern _MODULE MM_XScrollQueue;
extern _MODULE MM_MText;
extern _MODULE MM_TextList;
extern _MODULE MM_TextListSort;
extern _MODULE MM_ISOChar;
extern _MODULE MM_RT0;
extern _MODULE MM_RTAllocator;
extern _MODULE MM_RTCollector;
extern _MODULE MM_RTHeap;
extern _MODULE MM_RTTypeFP;
extern _MODULE MM_RTTypeMap;
extern _MODULE MM_RdImpl;
extern _MODULE MM_Uerror;
extern _MODULE MM_Uin;
extern _MODULE MM_Utypes;
extern _MODULE MM_FilePosix;
extern _MODULE MM_WrPosix;
extern _MODULE MM_XEventQueue;
extern _MODULE MM_IntTextTbl;
extern _MODULE MM_XAtomQueue;
extern _MODULE MM_RTMisc;
extern _MODULE MM_XProperties;
extern _MODULE MM_RTParams;
extern _MODULE MM_RTHeapRep;
extern _MODULE MM_RTHeapDep;
extern _MODULE MM_XInput;
extern _MODULE MM_XMessenger;
extern _MODULE MM_XExtensions;
extern _MODULE MM_IEEESpecial;
extern _MODULE MM_FmtBuf;
extern _MODULE MM_ExtendedFloat;
extern _MODULE MI_FmtBufTest;
extern _MODULE MI_XPaint;
extern _MODULE MI_XGC;
extern _MODULE MI_Extended;
extern _MODULE MI_JvsProtocol;
extern _MODULE MI_JvaProtocol;
extern _MODULE MI_Fingerprint;
extern _MODULE MI_XScrnFont;
extern _MODULE MI_XScrnCrsr;
extern _MODULE MI_Swap;
extern _MODULE MI_XScrnPntOp;
extern _MODULE MI_XScrnTpRep;
extern _MODULE MI_XScrnPxmp;
extern _MODULE MI_XCursors;
extern _MODULE MI_Utime;
extern _MODULE MI_RegionRep;
extern _MODULE MI_TrslOnXF;
extern _MODULE MI_XClientF;
extern _MODULE MI_IntRefTbl;
extern _MODULE MI_TrestleOnX;
extern _MODULE MI_OSErrorPosix;
extern _MODULE MI_Ushm;
extern _MODULE MI_Uutmp;
extern _MODULE MI_XClient;
extern _MODULE MI_jvprotocol;
extern _MODULE MI_Uugid;
extern _MODULE MI_Upwd;
extern _MODULE MI_TextRefTbl;
extern _MODULE MI_Refany;
extern _MODULE MI_MiscDetail;
extern _MODULE MI_WeakRef;
extern _MODULE MI_JVFromSource;
extern _MODULE MI_JVSinkPool;
extern _MODULE MI_TrestleGoo;
extern _MODULE MI_Cstdlib;
extern _MODULE MI_RTArgs;
extern _MODULE MI_RTType;
extern _MODULE MI_Property;
extern _MODULE MI_PropertyF;
extern _MODULE MI_AtomAtomTbl;
extern _MODULE MI_Herrno;
extern _MODULE MI_Unetdb;
extern _MODULE MI_DpyFilter;
extern _MODULE MI_InstallQueue;
extern _MODULE MI_InstalledVBT;
extern _MODULE MI_TrestleOS;
extern _MODULE MI_TrestleConf;
extern _MODULE MI_JVConverterF;
extern _MODULE MI_VideoVBTRep;
extern _MODULE MI_JVFromDecomp;
extern _MODULE MI_JVDecompPool;
extern _MODULE MI_XScrnCmap;
extern _MODULE MI_ScrnColorMap;
extern _MODULE MI_TrestleClass;
extern _MODULE MI_BasicCtypes;
extern _MODULE MI_JVBuffer;
extern _MODULE MI_XScreenType;
extern _MODULE MI_JVDecomp;
extern _MODULE MI_PaintExt;
extern _MODULE MI_Jvs;
extern _MODULE MI_JvsBuffer;
extern _MODULE MI_Point;
extern _MODULE MI_Region;
extern _MODULE MI_Tick;
extern _MODULE MI_PaintPrivate;
extern _MODULE MI_Picture;
extern _MODULE MI_TextSeqRep;
extern _MODULE MI_TextSeq;
extern _MODULE MI_JVAudio;
extern _MODULE MI_XSharedMem;
extern _MODULE MI_XPicture;
extern _MODULE MI_JVConverter;
extern _MODULE MI_Jv;
extern _MODULE MI_AtomList;
extern _MODULE MI_Cerrno;
extern _MODULE MI_Uuio;
extern _MODULE MI_TCPHack;
extern _MODULE MI_Rect;
extern _MODULE MI_X;
extern _MODULE MI_ScreenType;
extern _MODULE MI_StubImages;
extern _MODULE MI_PictureRep;
extern _MODULE MI_CompletionSeqRep;
extern _MODULE MI_CompletionSeq;
extern _MODULE MI_Completion;
extern _MODULE MI_ShadowedBarVBT;
extern _MODULE MI_Uexec;
extern _MODULE MI_StableVBT;
extern _MODULE MI_VideoVBT;
extern _MODULE MI_ZGrowVBT;
extern _MODULE MI_Integer;
extern _MODULE MI_ZTilps;
extern _MODULE MI_TCPSpecial;
extern _MODULE MI_Uresource;
extern _MODULE MI_RealFloat;
extern _MODULE MI_FS;
extern _MODULE MI_RegularFile;
extern _MODULE MI_LongReal;
extern _MODULE MI_LongFloat;
extern _MODULE MI_Math;
extern _MODULE MI_RigidVBT;
extern _MODULE MI_ZMoveVBT;
extern _MODULE MI_ETAgent;
extern _MODULE MI_PackSplit;
extern _MODULE MI_BdrVBTClass;
extern _MODULE MI_AtomIntTbl;
extern _MODULE MI_BiFeedbackVBT;
extern _MODULE MI_FeedbackVBT;
extern _MODULE MI_Image;
extern _MODULE MI_MarginFeedbackVBT;
extern _MODULE MI_MultiFilter;
extern _MODULE MI_ViewportVBT;
extern _MODULE MI_Uipc;
extern _MODULE MI_Pixmap;
extern _MODULE MI_Key;
extern _MODULE MI_Batch;
extern _MODULE MI_BatchUtil;
extern _MODULE MI_BatchRep;
extern _MODULE MI_JoinScreen;
extern _MODULE MI_ScrnCursor;
extern _MODULE MI_ScrnPaintOp;
extern _MODULE MI_Trapezoid;
extern _MODULE MI_ScrnPixmap;
extern _MODULE MI_ShadowPaint;
extern _MODULE MI_VBTKitResources;
extern _MODULE MI_HVBar;
extern _MODULE MI_JoinedVBT;
extern _MODULE MI_JoinParent;
extern _MODULE MI_OffsetVBT;
extern _MODULE MI_AutoRepeat;
extern _MODULE MI_VBTColors;
extern _MODULE MI_Pickle;
extern _MODULE MI_Scheduler;
extern _MODULE MI_RTHeapInfo;
extern _MODULE MI_TrestleImpl;
extern _MODULE MI_VBTKitBundle;
extern _MODULE MI_PropertyV;
extern _MODULE MI_RTModule;
extern _MODULE MI_RTMapOp;
extern _MODULE MI_RTHeapMap;
extern _MODULE MI_RTHeapEvent;
extern _MODULE MI_IntIntTbl;
extern _MODULE MI_RTProcedure;
extern _MODULE MI_STypeMapSeqRep;
extern _MODULE MI_FormsVBTPixmapsBundle;
extern _MODULE MI_SortedTextRefTbl;
extern _MODULE MI_IvyModel;
extern _MODULE MI_VBTutils;
extern _MODULE MI_TextVBTClass;
extern _MODULE MI_VBTTuning;
extern _MODULE MI_BtnVBTClass;
extern _MODULE MI_ProperSplit;
extern _MODULE MI_MenuBtnVBT;
extern _MODULE MI_ScrollerVBTClass;
extern _MODULE MI_AnchorBtnVBT;
extern _MODULE MI_AudioVBT;
extern _MODULE MI_BorderedVBT;
extern _MODULE MI_AnchorSplit;
extern _MODULE MI_AnyEvent;
extern _MODULE MI_GuardedBtnVBT;
extern _MODULE MI_Axis;
extern _MODULE MI_BooleanVBT;
extern _MODULE MI_ChoiceVBT;
extern _MODULE MI_ButtonVBT;
extern _MODULE MI_ColorName;
extern _MODULE MI_Color;
extern _MODULE MI_FileBrowserVBT;
extern _MODULE MI_Cursor;
extern _MODULE MI_FlexVBT;
extern _MODULE MI_FileRd;
extern _MODULE MI_RTOS;
extern _MODULE MI_RTException;
extern _MODULE MI_Font;
extern _MODULE MI_Jva;
extern _MODULE MI_HighlightVBT;
extern _MODULE MI_HVSplit;
extern _MODULE MI_JVSink;
extern _MODULE MI_ListVBT;
extern _MODULE MI_MenuSwitchVBT;
extern _MODULE MI_MultiSplit;
extern _MODULE MI_MultiClass;
extern _MODULE MI_NumericVBT;
extern _MODULE MI_PaintOp;
extern _MODULE MI_RTExRep;
extern _MODULE MI_Pathname;
extern _MODULE MI_PixmapVBT;
extern _MODULE MI_Pts;
extern _MODULE MI_ReactivityVBT;
extern _MODULE MI_RTTypeSRC;
extern _MODULE MI_ScaleFilter;
extern _MODULE MI_ScrollerVBT;
extern _MODULE MI_Shadow;
extern _MODULE MI_ShadowedVBT;
extern _MODULE MI_ShadowedFeedbackVBT;
extern _MODULE MI_SourceVBT;
extern _MODULE MI_Cstddef;
extern _MODULE MI_Split;
extern _MODULE MI_SplitterVBT;
extern _MODULE MI_SwitchVBT;
extern _MODULE MI_TextPortClass;
extern _MODULE MI_TextRd;
extern _MODULE MI_TextureVBT;
extern _MODULE MI_TextVBT;
extern _MODULE MI_TextWr;
extern _MODULE MI_TrillSwitchVBT;
extern _MODULE MI_TSplit;
extern _MODULE MI_TextIntTbl;
extern _MODULE MI_TypeinVBT;
extern _MODULE MI_TypescriptVBT;
extern _MODULE MI_ZChassisVBT;
extern _MODULE MI_ZChildVBT;
extern _MODULE MI_ZSplit;
extern _MODULE MI_ZSplitUtils;
extern _MODULE MI_StubImageRd;
extern _MODULE MI_StubImageVBT;
extern _MODULE MI_FVTypes;
extern _MODULE MI_Path;
extern _MODULE MI_JoinFont;
extern _MODULE MI_JoinCursor;
extern _MODULE MI_JoinCMap;
extern _MODULE MI_XMachine;
extern _MODULE MI_Csignal;
extern _MODULE MI_Csetjmp;
extern _MODULE MI_RTMachine;
extern _MODULE MI_RT0u;
extern _MODULE MI_RTPerfTool;
extern _MODULE MI_RTProcedureSRC;
extern _MODULE MI_RTThread;
extern _MODULE MI_RTIO;
extern _MODULE MI_ThreadEvent;
extern _MODULE MI_ThreadF;
extern _MODULE MI_RTThreadInit;
extern _MODULE MI_STypeMapSeq;
extern _MODULE MI_STypeMap;
extern _MODULE MI_JoinPixmap;
extern _MODULE MI_PlttFrnds;
extern _MODULE MI_JoinPaintOp;
extern _MODULE MI_SelectQueue;
extern _MODULE MI_ComplSeqRep;
extern _MODULE MI_MTextRd;
extern _MODULE MI_TextEditVBT;
extern _MODULE MI_VTDef;
extern _MODULE MI_VText;
extern _MODULE MI_KeyTrans;
extern _MODULE MI_MTextUnit;
extern _MODULE MI_EmacsModel;
extern _MODULE MI_XtermModel;
extern _MODULE MI_XImUtil;
extern _MODULE MI_Compl;
extern _MODULE MI_ComplSeq;
extern _MODULE MI_XShm;
extern _MODULE MI_AtomRefTbl;
extern _MODULE MI_ASCII;
extern _MODULE MI_DragonInt;
extern _MODULE MI_FVRuntime;
extern _MODULE MI_Sx;
extern _MODULE MI_Macro;
extern _MODULE MI_DragonT;
extern _MODULE MI_TextPort;
extern _MODULE MI_RealRep;
extern _MODULE MI_LongRealRep;
extern _MODULE MI_FPU;
extern _MODULE MI_Atom;
extern _MODULE MI_RefList;
extern _MODULE MI_RefListUtils;
extern _MODULE MI_Date;
extern _MODULE MI_Time;
extern _MODULE MI_TimePosix;
extern _MODULE MI_CConvert;
extern _MODULE MI_Ctypes;
extern _MODULE MI_M3toC;
extern _MODULE MI_Cstring;
extern _MODULE MI_TextF;
extern _MODULE MI_Word;
extern _MODULE MI_Bundle;
extern _MODULE MI_BundleRep;
extern _MODULE MI_Latin1Key;
extern _MODULE MI_Env;
extern _MODULE MI_KeyboardKey;
extern _MODULE MI_KeyFilter;
extern _MODULE MI_TimeStamp;
extern _MODULE MI_MacModel;
extern _MODULE MI_Real;
extern _MODULE MI_Xatom;
extern _MODULE MI_Poly;
extern _MODULE MI_PolyBasis;
extern _MODULE MI_RTWeakRef;
extern _MODULE MI_VT;
extern _MODULE MI_Interval;
extern _MODULE MI_MD2;
extern _MODULE MI_VTTexture;
extern _MODULE MI_VTInterval;
extern _MODULE MI_VTMarker;
extern _MODULE MI_VTPounce;
extern _MODULE MI_PathPrivate;
extern _MODULE MI_VBTRep;
extern _MODULE MI_RdClass;
extern _MODULE MI_WrClass;
extern _MODULE MI_MouseSplit;
extern _MODULE MI_VBTClass;
extern _MODULE MI_Udir;
extern _MODULE MI_Filter;
extern _MODULE MI_FilterClass;
extern _MODULE MI_RTHooks;
extern _MODULE MI_IP;
extern _MODULE MI_TCP;
extern _MODULE MI_Text;
extern _MODULE MI_Convert;
extern _MODULE MI_Tempo;
extern _MODULE MI_PolyRegion;
extern _MODULE MI_IO;
extern _MODULE MI_Wr;
extern _MODULE MI_Stdio;
extern _MODULE MI_Process;
extern _MODULE MI_OSError;
extern _MODULE MI_RdUtils;
extern _MODULE MI_ConnFD;
extern _MODULE MI_ConnMsgRW;
extern _MODULE MI_MsgRd;
extern _MODULE MI_MsgWr;
extern _MODULE MI_Usignal;
extern _MODULE MI_Random;
extern _MODULE MI_Params;
extern _MODULE MI_File;
extern _MODULE MI_FileWr;
extern _MODULE MI_FloatMode;
extern _MODULE MI_Fmt;
extern _MODULE MI_FormsVBT;
extern _MODULE MI_Lex;
extern _MODULE MI_Rd;
extern _MODULE MI_Rsrc;
extern _MODULE MI_Scan;
extern _MODULE MI_Thread;
extern _MODULE MI_Trestle;
extern _MODULE MI_TrestleComm;
extern _MODULE MI_VBT;
extern _MODULE MI_Main;
extern _MODULE MI_CalculatorBundle;
extern _MODULE MI_RTLinker;
extern _MODULE MI_RTProcess;
extern _MODULE MI_RTSignal;
extern _MODULE MI_Uprocess;
extern _MODULE MI_RefListSort;
extern _MODULE MI_Palette;
extern _MODULE MI_ScrnFont;
extern _MODULE MI_VTCaret;
extern _MODULE MI_M3_BUILTIN;
extern _MODULE MI_VTRd;
extern _MODULE MI_VTBase;
extern _MODULE MI_VTextDef;
extern _MODULE MI_Pipe;
extern _MODULE MI_Terminal;
extern _MODULE MI_Ustat;
extern _MODULE MI_RandomReal;
extern _MODULE MI_Unix;
extern _MODULE MI_SchedulerPosix;
extern _MODULE MI_VTReal;
extern _MODULE MI_VTView;
extern _MODULE MI_VTVirtual;
extern _MODULE MI_VTextRegion;
extern _MODULE MI_TimeStampRep;
extern _MODULE MI_MachineID;
extern _MODULE MI_MTextDs;
extern _MODULE MI_XScrollQueue;
extern _MODULE MI_MTextPrivate;
extern _MODULE MI_MText;
extern _MODULE MI_ISOChar;
extern _MODULE MI_TextListSort;
extern _MODULE MI_TextList;
extern _MODULE MI_RT0;
extern _MODULE MI_RTAllocator;
extern _MODULE MI_RTCollector;
extern _MODULE MI_RTHeap;
extern _MODULE MI_RTTypeFP;
extern _MODULE MI_RTTypeMap;
extern _MODULE MI_ColorNameF;
extern _MODULE MI_ColorNameTable;
extern _MODULE MI_TCPPosix;
extern _MODULE MI_Uerror;
extern _MODULE MI_Uin;
extern _MODULE MI_Utypes;
extern _MODULE MI_XAtomQueue;
extern _MODULE MI_FilePosix;
extern _MODULE MI_Usocket;
extern _MODULE MI_IntTextTbl;
extern _MODULE MI_UnsafeRd;
extern _MODULE MI_UnsafeWr;
extern _MODULE MI_XEventQueue;
extern _MODULE MI_RTMisc;
extern _MODULE MI_XProperties;
extern _MODULE MI_RTParams;
extern _MODULE MI_RTHeapRep;
extern _MODULE MI_RTCollectorSRC;
extern _MODULE MI_RTHeapDep;
extern _MODULE MI_XInput;
extern _MODULE MI_XMessenger;
extern _MODULE MI_XExtensions;
extern _MODULE MI_XClientExt;
extern _MODULE MI_IEEESpecial;
extern _MODULE MI_FmtBuf;
extern _MODULE MI_ExtendedFloat;
extern _MODULE MI_FmtBufF;

static _MODULE *_modules[719] = {
  &MI_RTHeap,
  &MI_RTHeapInfo,
  &MI_Uprocess,
  &MI_Csignal,
  &MI_RTSignal,
  &MI_TimePosix,
  &MI_Time,
  &MI_ThreadEvent,
  &MI_Usignal,
  &MI_RTThread,
  &MI_PolyBasis,
  &MI_Poly,
  &MI_Fingerprint,
  &MI_RTProcedure,
  &MI_RTProcedureSRC,
  &MI_Cerrno,
  &MI_RTThreadInit,
  &MI_SchedulerPosix,
  &MI_Scheduler,
  &MI_FloatMode,
  &MI_ThreadF,
  &MI_Thread,
  &MI_RTExRep,
  &MI_RTException,
  &MI_RTProcess,
  &MI_Uresource,
  &MI_Uexec,
  &MI_RTPerfTool,
  &MI_M3toC,
  &MI_RTArgs,
  &MI_RTParams,
  &MI_Cstddef,
  &MI_Cstdlib,
  &MI_Uuio,
  &MI_Utime,
  &MI_Utypes,
  &MI_Unix,
  &MI_RTOS,
  &MI_Text,
  &MI_TextF,
  &MI_RTIO,
  &MI_RTTypeMap,
  &MI_RTMapOp,
  &MI_RTModule,
  &MI_RTHeapMap,
  &MI_RTHeapEvent,
  &MI_RTWeakRef,
  &MI_RTCollectorSRC,
  &MI_RTCollector,
  &MI_Csetjmp,
  &MI_RTMachine,
  &MI_RTHeapDep,
  &MI_RTHeapRep,
  &MI_Word,
  &MI_BasicCtypes,
  &MI_Ctypes,
  &MI_Cstring,
  &MI_RTMisc,
  &MI_RT0u,
  &MI_RTTypeSRC,
  &MI_RT0,
  &MI_RTType,
  &MI_RTAllocator,
  &MI_RTHooks,
  &MI_RTLinker,
  &MI_M3_BUILTIN,
  &MM_RTHeap,
  &MM_RTHeapInfo,
  &MM_RTSignal,
  &MM_RTLinker,
  &MM_RTHooks,
  &MM_TimePosix,
  &MM_RTThreadStk,
  &MM_RTThread,
  &MM_Usignal,
  &MM_RTProcedure,
  &MM_PolyBasis,
  &MM_Poly,
  &MM_Fingerprint,
  &MM_FloatMode,
  &MM_ThreadPosix,
  &MM_RTException,
  &MM_RTProcess,
  &MM_RTPerfTool,
  &MM_M3toC,
  &MM_RTArgs,
  &MM_RTParams,
  &MM_Utypes,
  &MM_RTOS,
  &MM_UnsafeHash,
  &MM_Text,
  &MM_RTIO,
  &MM_RTMapOp,
  &MM_RTTypeMap,
  &MM_RTModule,
  &MM_RTHeapMap,
  &MM_RTCollector,
  &MM_RTHeapRep,
  &MM_RTHeapDep,
  &MM_Word,
  &MM_RTMisc,
  &MM_RT0u,
  &MM_RTType,
  &MM_RT0,
  &MM_RTAllocator,

  &MI_AtomAtomTbl,
  &MI_Atom,
  &MM_AtomAtomTbl,
  &MM_Atom,

  &MI_AtomList,
  &MM_AtomList,

  &MI_Herrno,

  &MI_Unetdb,
  &MM_Unetdb,

  &MI_Usocket,

  &MI_CConvert,
  &MM_CConvert,

  &MI_Convert,
  &MM_Convert,

  &MI_UnsafeWr,
  &MI_WrClass,
  &MI_Wr,
  &MM_WrMove,
  &MM_WrPosix,

  &MI_UnsafeRd,
  &MI_RdClass,
  &MI_Rd,
  &MM_RdMove,
  &MM_RdImpl,

  &MI_ConnFD,

  &MI_Uerror,
  &MM_Uerror,

  &MI_TCPHack,
  &MM_TCPHack,

  &MI_Real,
  &MM_Real,

  &MI_LongReal,
  &MM_LongReal,

  &MI_Extended,
  &MM_Extended,

  &MI_RealRep,

  &MI_DragonInt,
  &MM_DragonInt,

  &MI_DragonT,
  &MM_DragonT,

  &MI_FPU,
  &MM_FPU,

  &MI_RealFloat,
  &MM_RealFloat,

  &MI_LongRealRep,

  &MI_LongFloat,
  &MM_LongFloat,

  &MI_ExtendedFloat,
  &MM_ExtendedFloat,

  &MI_TextSeqRep,
  &MI_TextSeq,
  &MM_TextSeq,

  &MI_Pathname,
  &MM_PathnamePosix,

  &MI_Env,
  &MM_Env,

  &MI_Ustat,

  &MI_Udir,

  &MI_Uugid,

  &MI_Terminal,
  &MI_RegularFile,
  &MI_FS,
  &MI_Pipe,
  &MI_FilePosix,
  &MI_OSErrorPosix,
  &MI_OSError,
  &MI_File,
  &MI_Process,
  &MI_FmtBufTest,
  &MI_FmtBufF,
  &MI_FmtBuf,
  &MI_Fmt,
  &MM_Terminal,
  &MM_RegularFile,
  &MM_FSPosix,
  &MM_FilePosix,
  &MM_PipePosix,
  &MM_Pipe,
  &MM_ProcessPosix,
  &MM_OSErrorPosix,
  &MM_FmtBuf,
  &MM_Fmt,

  &MI_TCPPosix,
  &MI_TCPSpecial,
  &MI_TCP,
  &MI_Uin,
  &MI_IP,
  &MM_TCP,
  &MM_Uin,
  &MM_IP,

  &MI_FileRd,
  &MM_FileRd,

  &MI_FileWr,
  &MM_FileWr,

  &MI_Stdio,
  &MM_Stdio,

  &MI_IEEESpecial,
  &MM_IEEESpecial,

  &MI_Lex,
  &MM_Lex,

  &MI_IO,
  &MM_IO,

  &MI_Date,
  &MM_DateLinux,

  &MI_Tempo,
  &MM_Tempo,

  &MI_MD2,
  &MM_MD2,

  &MI_ASCII,
  &MM_ASCII,

  &MI_TextWr,
  &MM_TextWr,

  &MI_RdUtils,
  &MM_RdUtils,

  &MI_MsgRd,

  &MI_MsgWr,

  &MI_Swap,
  &MM_Swap,

  &MI_ConnMsgRW,
  &MM_ConnMsgRW,

  &MI_Tick,
  &MM_TickPortable,

  &MI_TimeStampRep,

  &MI_MachineID,
  &MM_MachineIDPosix,

  &MI_TimeStamp,
  &MM_TimeStamp,

  &MI_RandomReal,
  &MI_Random,
  &MM_RandomReal,
  &MM_Random,

  &MI_Params,
  &MM_Params,

  &MI_BundleRep,
  &MI_Bundle,
  &MM_Bundle,

  &MI_CalculatorBundle,
  &MM_CalculatorBundle,

  &MI_Axis,
  &MM_Axis,

  &MI_Point,
  &MM_Point,

  &MI_Interval,
  &MM_Interval,

  &MI_Rect,
  &MM_Rect,

  &MI_RegionRep,
  &MI_Region,
  &MM_Region,

  &MI_Trapezoid,
  &MM_Trapezoid,

  &MI_PathPrivate,
  &MI_Path,
  &MM_Path,

  &MI_TrestleComm,

  &MI_PaintPrivate,
  &MM_PaintPrivate,

  &MI_ScrnColorMap,
  &MM_ScrnColorMap,

  &MI_VBTTuning,

  &MI_XMachine,

  &MI_X,

  &MI_WeakRef,
  &MM_WeakRef,

  &MI_PropertyF,
  &MI_Property,
  &MM_Property,

  &MI_PropertyV,
  &MM_PropertyV,

  &MI_Integer,
  &MM_Integer,

  &MI_Refany,
  &MM_Refany,

  &MI_IntRefTbl,
  &MM_IntRefTbl,

  &MI_InstallQueue,
  &MM_InstallQueue,

  &MI_TextRefTbl,
  &MM_TextRefTbl,

  &MI_MiscDetail,
  &MM_MiscDetail,

  &MI_TrestleConf,
  &MM_TrestleConf,

  &MI_Uutmp,

  &MI_Upwd,

  &MI_XEventQueue,
  &MM_XEventQueue,

  &MI_Math,
  &MM_Math,

  &MI_XCursors,

  &MI_PolyRegion,
  &MM_PolyRegion,

  &MI_XScrollQueue,
  &MM_XScrollQueue,

  &MI_Xatom,

  &MI_IntTextTbl,
  &MM_IntTextTbl,

  &MI_TextIntTbl,
  &MM_TextIntTbl,

  &MI_XAtomQueue,
  &MM_XAtomQueue,

  &MI_KeyboardKey,

  &MI_XShm,

  &MI_IntIntTbl,
  &MM_IntIntTbl,

  &MI_XImUtil,

  &MI_RTTypeFP,
  &MM_RTTypeFP,

  &MI_Pickle,
  &MM_Pickle,

  &MI_TextRd,
  &MM_TextRd,

  &MI_CompletionSeqRep,
  &MI_CompletionSeq,
  &MI_XClientExt,
  &MI_ComplSeqRep,
  &MI_ComplSeq,
  &MI_Compl,
  &MI_XSharedMem,
  &MI_XExtensions,
  &MI_XMessenger,
  &MI_XInput,
  &MI_XProperties,
  &MI_PaintExt,
  &MI_XPaint,
  &MI_XGC,
  &MI_XScrnPntOp,
  &MI_XScrnPxmp,
  &MI_XScrnCrsr,
  &MI_XScrnCmap,
  &MI_XScrnFont,
  &MI_XScrnTpRep,
  &MI_XScreenType,
  &MI_TrslOnXF,
  &MI_TrestleOnX,
  &MI_TrestleOS,
  &MI_TrestleGoo,
  &MI_StableVBT,
  &MI_HighlightVBT,
  &MI_DpyFilter,
  &MI_InstalledVBT,
  &MI_ProperSplit,
  &MI_STypeMapSeqRep,
  &MI_STypeMap,
  &MI_STypeMapSeq,
  &MI_JoinCMap,
  &MI_JoinPaintOp,
  &MI_JoinCursor,
  &MI_JoinFont,
  &MI_JoinScreen,
  &MI_JoinPixmap,
  &MI_JoinedVBT,
  &MI_SelectQueue,
  &MI_FilterClass,
  &MI_Filter,
  &MI_ETAgent,
  &MI_JoinParent,
  &MI_Split,
  &MI_MouseSplit,
  &MI_VBTClass,
  &MI_TrestleClass,
  &MI_TrestleImpl,
  &MI_Trestle,
  &MI_XClient,
  &MI_XClientF,
  &MI_XPicture,
  &MI_Picture,
  &MI_Completion,
  &MI_PictureRep,
  &MI_BatchUtil,
  &MI_BatchRep,
  &MI_Batch,
  &MI_VBTRep,
  &MI_Cursor,
  &MI_ScrnCursor,
  &MI_ScreenType,
  &MI_Font,
  &MI_ScrnPixmap,
  &MI_ScrnFont,
  &MI_ScrnPaintOp,
  &MI_PlttFrnds,
  &MI_PaintOp,
  &MI_Palette,
  &MI_Pixmap,
  &MI_VBT,
  &MM_VBT,
  &MM_VBTRep,
  &MM_CompletionSeq,
  &MM_Completion,
  &MM_Picture,
  &MM_ComplSeq,
  &MM_Compl,
  &MM_XSharedMem,
  &MM_XSharedFree,
  &MM_XExtensions,
  &MM_XMessenger,
  &MM_XInput,
  &MM_XClientF,
  &MM_XProperties,
  &MM_XPaint,
  &MM_XGC,
  &MM_XScrnPntOp,
  &MM_XScrnCrsr,
  &MM_XScrnPxmp,
  &MM_XScrnCmap,
  &MM_XScrnFont,
  &MM_XScrnTpRep,
  &MM_XScreenType,
  &MM_XClient,
  &MM_TrestleOnX,
  &MM_TrestleOS,
  &MM_TrestleGoo,
  &MM_StableVBT,
  &MM_HighlightVBT,
  &MM_InstalledVBT,
  &MM_DpyFilter,
  &MM_ProperSplit,
  &MM_JoinParent,
  &MM_STypeMapSeq,
  &MM_JoinPixmap,
  &MM_JoinCMap,
  &MM_JoinPaintOp,
  &MM_JoinCursor,
  &MM_JoinFont,
  &MM_JoinScreen,
  &MM_JoinedVBT,
  &MM_SelectQueue,
  &MM_ETAgent,
  &MM_FilterClass,
  &MM_Filter,
  &MM_Split,
  &MM_MouseSplit,
  &MM_VBTClass,
  &MM_TrestleClass,
  &MM_Trestle,
  &MM_XPicture,
  &MM_XPictureFree,
  &MM_PictureImpl,
  &MM_BatchUtil,
  &MM_Batch,
  &MM_Palette,
  &MM_PlttFrnds,
  &MM_ScrnFont,
  &MM_ScreenType,
  &MM_ScrnCursor,
  &MM_Cursor,
  &MM_Font,
  &MM_ScrnPixmap,
  &MM_ScrnPaintOp,
  &MM_PaintOp,
  &MM_Pixmap,

  &MI_AnyEvent,
  &MM_AnyEvent,

  &MI_Color,
  &MM_Color,

  &MI_RefList,
  &MM_RefList,

  &MI_Sx,
  &MM_Sx,

  &MI_ZSplit,
  &MM_ZSplit,

  &MI_Rsrc,
  &MM_Rsrc,

  &MI_PackSplit,
  &MM_PackSplit,

  &MI_BtnVBTClass,
  &MI_ButtonVBT,
  &MM_ButtonVBT,

  &MI_FeedbackVBT,
  &MM_FeedbackVBT,

  &MI_MultiSplit,
  &MI_MultiClass,
  &MM_MultiSplit,
  &MM_MultiClass,

  &MI_MultiFilter,
  &MM_MultiFilter,

  &MI_BooleanVBT,
  &MM_BooleanVBT,

  &MI_ChoiceVBT,
  &MM_ChoiceVBT,

  &MI_FlexVBT,
  &MM_FlexVBT,

  &MI_Jv,
  &MM_Jv,

  &MI_JvaProtocol,
  &MI_Jva,
  &MM_Jva,

  &MI_JVAudio,
  &MM_JVAudio,

  &MI_JVBuffer,
  &MM_JVBuffer,

  &MI_JVConverterF,
  &MI_JVConverter,
  &MM_JVConverter,

  &MI_AudioVBT,
  &MM_AudioVBT,

  &MI_AnchorBtnVBT,
  &MM_AnchorBtnVBT,

  &MI_SwitchVBT,
  &MM_SwitchVBT,

  &MI_AnchorSplit,
  &MM_AnchorSplit,

  &MI_BdrVBTClass,
  &MI_BorderedVBT,
  &MM_BorderedVBT,

  &MI_HVSplit,
  &MM_HVSplit,

  &MI_AutoRepeat,
  &MM_AutoRepeat,

  &MI_RigidVBT,
  &MM_RigidVBT,

  &MI_ScaleFilter,
  &MM_ScaleFilter,

  &MI_Image,
  &MM_Image,

  &MI_VBTKitBundle,
  &MM_VBTKitBundle,

  &MI_VBTKitResources,
  &MM_VBTKitResources,

  &MI_ScrollerVBT,
  &MI_ScrollerVBTClass,
  &MM_ScrollerVBTClass,
  &MM_ScrollerVBT,

  &MI_TextureVBT,
  &MM_TextureVBT,

  &MI_ListVBT,
  &MM_ListVBT,

  &MI_Shadow,
  &MM_Shadow,

  &MI_TextList,
  &MM_TextList,

  &MI_MTextDs,
  &MI_MTextPrivate,
  &MI_MText,
  &MM_MTextDs,
  &MM_MText,

  &MI_MTextRd,
  &MM_MTextRd,

  &MI_VTDef,

  &MI_VTextDef,

  &MI_VTRd,
  &MM_VTRd,

  &MI_VTBase,
  &MM_VTBase,

  &MI_VTTexture,
  &MM_VTTexture,

  &MI_RefListSort,
  &MM_RefListSort,

  &MI_Pts,
  &MM_Pts,

  &MI_ISOChar,
  &MM_ISOChar,

  &MI_VTextRegion,
  &MI_VTPounce,
  &MI_VTView,
  &MI_VTVirtual,
  &MI_VTMarker,
  &MI_VTCaret,
  &MI_VTReal,
  &MI_VTInterval,
  &MI_VT,
  &MI_VText,
  &MM_VTextRegion,
  &MM_VTPounce,
  &MM_VTView,
  &MM_VTVirtual,
  &MM_VTMarker,
  &MM_VTCaret,
  &MM_VTReal,
  &MM_VTInterval,
  &MM_VT,
  &MM_VText,

  &MI_Latin1Key,

  &MI_KeyFilter,
  &MM_KeyFilter,

  &MI_Key,
  &MM_Key,

  &MI_KeyTrans,
  &MM_KeyTrans,

  &MI_MTextUnit,
  &MM_MTextUnit,

  &MI_VBTutils,
  &MM_VBTutils,

  &MI_XtermModel,
  &MI_IvyModel,
  &MI_EmacsModel,
  &MI_TextEditVBT,
  &MI_TypescriptVBT,
  &MI_TextPortClass,
  &MI_MacModel,
  &MI_TextPort,
  &MM_XtermModel,
  &MM_IvyModel,
  &MM_EmacsModel,
  &MM_MacModel,
  &MM_TypescriptVBT,
  &MM_TextEditVBT,
  &MM_TextPortClass,
  &MM_TextPort,

  &MI_TypeinVBT,
  &MM_TypeinVBT,

  &MI_TextVBTClass,
  &MI_TextVBT,
  &MM_TextVBT,

  &MI_MenuBtnVBT,
  &MM_MenuBtnVBT,

  &MI_MenuSwitchVBT,
  &MM_MenuSwitchVBT,

  &MI_ShadowPaint,
  &MM_ShadowPaint,

  &MI_ShadowedVBT,
  &MM_ShadowedVBT,

  &MI_ShadowedFeedbackVBT,
  &MM_ShadowedFeedbackVBT,

  &MI_TextListSort,
  &MM_TextListSort,

  &MI_FileBrowserVBT,
  &MM_FileBrowserVBT,

  &MI_ReactivityVBT,
  &MM_ReactivityVBT,

  &MI_GuardedBtnVBT,
  &MM_GuardedBtnVBT,

  &MI_PixmapVBT,
  &MM_PixmapVBT,

  &MI_TrillSwitchVBT,
  &MM_TrillSwitchVBT,

  &MI_NumericVBT,
  &MM_NumericVBT,

  &MI_ShadowedBarVBT,
  &MM_ShadowedBarVBT,

  &MI_SourceVBT,
  &MM_SourceVBT,

  &MI_HVBar,
  &MM_HVBar,

  &MI_SplitterVBT,
  &MM_SplitterVBT,

  &MI_TSplit,
  &MM_TSplit,

  &MI_JvsProtocol,

  &MI_Jvs,
  &MM_Jvs,

  &MI_Uipc,

  &MI_Ushm,

  &MI_JvsBuffer,
  &MM_JvsBuffer,

  &MI_jvprotocol,

  &MI_JVFromSource,
  &MM_JVFromSource,

  &MI_JVFromDecomp,
  &MM_JVFromDecomp,

  &MI_JVDecomp,
  &MM_JVDecomp,

  &MI_JVSink,
  &MM_JVSink,

  &MI_JVSinkPool,
  &MM_JVSinkPool,

  &MI_JVDecompPool,
  &MM_JVDecompPool,

  &MI_VideoVBTRep,
  &MI_VideoVBT,
  &MM_VideoVBT,

  &MI_OffsetVBT,
  &MM_OffsetVBT,

  &MI_ViewportVBT,
  &MM_ViewportVBT,

  &MI_ZChildVBT,
  &MM_ZChildVBT,

  &MI_VBTColors,
  &MM_VBTColors,

  &MI_ZSplitUtils,
  &MM_ZSplitUtils,

  &MI_ZMoveVBT,
  &MM_ZMoveVBT,

  &MI_ZGrowVBT,
  &MM_ZGrowVBT,

  &MI_ZChassisVBT,
  &MM_ZChassisVBT,

  &MI_ZTilps,
  &MM_ZTilps,

  &MI_StubImages,

  &MI_StubImageVBT,
  &MM_StubImageVBT,

  &MI_ColorNameTable,

  &MI_ColorNameF,
  &MI_ColorName,
  &MM_ColorName,

  &MI_FormsVBTPixmapsBundle,
  &MM_FormsVBTPixmapsBundle,

  &MI_AtomRefTbl,
  &MM_AtomRefTbl,

  &MI_RefListUtils,
  &MM_RefListUtils,

  &MI_SortedTextRefTbl,
  &MM_SortedTextRefTbl,

  &MI_StubImageRd,
  &MM_StubImageRd,

  &MI_AtomIntTbl,
  &MM_AtomIntTbl,

  &MI_BiFeedbackVBT,
  &MM_BiFeedbackVBT,

  &MI_MarginFeedbackVBT,
  &MM_MarginFeedbackVBT,

  &MI_Macro,
  &MI_FVTypes,
  &MI_FVRuntime,
  &MI_FormsVBT,
  &MM_Macro,
  &MM_FVRuntime,
  &MM_FormsVBT,

  &MI_Scan,
  &MM_Scan,

  &MI_Main,
  &MM_Utex2,

  0
};

static _LINK_INFO _m3_link_info = {
  /* n_modules  */ 718,
  /* modules    */ (_ADDRESS)_modules,
  /* argc       */ 0,
  /* argv       */ 0,
  /* envp       */ 0,
  /* instance   */ 0,
  /* stack_bot  */ 0,
  /* stack_top  */ (_ADDRESS)0x400000
};

int main (argc, argv, envp)
int argc;
char **argv;
char **envp;
{
  { /* initialize RTLinker's global data */
    _LINKER* linker = (_LINKER*)&MI_RTLinker;
    linker->info = &_m3_link_info;
    _m3_link_info.argc = argc;
    _m3_link_info.argv = (_ADDRESS)(argv);
    _m3_link_info.envp = (_ADDRESS)(envp);
    _m3_link_info.instance = (_ADDRESS)(0);
    _m3_link_info.bottom_of_stack = (_ADDRESS)(&linker);
  };

  /* finally, start the Modula-3 program */
  MM_RTLinker.main ();
  return 0;
}

